/* global Bdf,$$,Pane */
/**
 * Objet global définissant l'espace de nom Balayage
 * 
 * @namespace Balayage
 */
var Balayage = {};

Balayage.array = null;


/******************************************************************************
 * Actions sur Balayage.array
 ******************************************************************************/

Balayage.initArray = function (array) {
    for(var i = 0, len = array.length; i < len; i++) {
        Balayage.completeBalayage(array[i]);
    }
    Balayage.array = array;
    return array;
};

Balayage.getBalayage = function (balayageName) {
    if (!Balayage.array) {
        return null;
    }
    for(let i = 0, len = Balayage.array.length; i < len; i++) {
        let balayage = Balayage.array[i];
        if (balayage.name === balayageName) {
            return balayage;
        }
    }
    return null;
};

Balayage.updateBalayage = function (newBalayage) {
    newBalayage = Balayage.completeBalayage(newBalayage);
    Bdf.updateInArray(Balayage.array, newBalayage);
    Balayage.List.updateBalayage(newBalayage);
    return newBalayage;
};

Balayage.removeBalayage = function (name) {
    Bdf.removeInArray(Balayage.array,name);
    Pane.removeContents(name);
    Pane.removeEntry($$("listpane_body"), name);
};

Balayage.insertBalayage = function (balayage) {
    balayage = Balayage.completeBalayage(balayage);
    Bdf.insertInArray(Balayage.array, balayage);
    var $entry = Pane.insertEntry($$("listpane_body"), balayage.name, Bdf.render("balayage:list/balayage", balayage));
    Bdf.Deploy.ensureLinkVisibility($entry, true);
    $$("listpane_body").animate({
        scrollTop: $entry.offset().top
    }, 1000);
    return balayage;
};

Balayage.completeBalayage = function (balayageObj) {
    var balayageName = balayageObj.name;
    _completeSubdir("_core");
    _completeSubdir("extraction");
    _completeSubdir("xslt");
    return balayageObj;
    
    function _completeSubdir(key) {
        if (balayageObj.hasOwnProperty(key)) {
            var array = balayageObj[key].array;
            for (var j = 0, len = array.length; j < len; j++) {
                array[j].balayageName = balayageName;
            }
        }
    }
    
};


/******************************************************************************
 * Enregistrement de fonction
 ******************************************************************************/

Pane.registerCheckFunction(function (state) {
    var mainContentKey, balayageName, contentPath;
    $(".pane-list-ActiveItem").removeClass("pane-list-ActiveItem");
    if (state.withMain()) {
        _init();
        let $balayage = Bdf.$({role: "entry", name: balayageName});
        Bdf.$($balayage, {role: "entry-header"}).addClass("pane-list-ActiveItem");
        let $reference = Bdf.$($balayage, {role: "content-reference", contentPath: contentPath});
        Bdf.$($reference, {role: "content-title"}).addClass("pane-list-ActiveItem");
        Pane.ensureVisibility($reference);
    }
    
    
    function _init() {
        mainContentKey = state.mainContentKey;
        let idx = mainContentKey.indexOf("/");
        balayageName = mainContentKey.substring(0, idx);
        contentPath = mainContentKey.substring(idx + 1);
    }
    
});


/******************************************************************************
 * Initialisation
 ******************************************************************************/

Bdf.addTemplateOptions({
    helpers: {
    }
});

$(function () {
    Bdf.initTemplates();
    Pane.initLayout();
    $$("layout_list").html(Bdf.render("balayage:list/pane", {}));
    Bdf.initBeforeUnload();
    Bdf.runSerialFunctions(
        Bdf.Ajax.initLangConfiguration,
        Balayage.List.init
    );
});
