/* global Bdf,Multi,Overlay,$,$$,Pane */

Multi.Metadata = {};

Multi.Metadata.init = function (callback) {
    Multi.Metadata.loadAjax(function (metadata) {
        Multi.Metadata.update(metadata);
        if (callback) {
            callback();
        }
    });
};

Multi.Metadata.update = function (metadata) {
    Multi.metadata = metadata;
    Bdf.langConfiguration = metadata.langConfiguration;
};

Multi.Metadata.load = function () {
    var formId = Bdf.generateId();
    var metadata = Multi.metadata;
    var attributesId = formId + "_attributes";
    $$("layout_main").html(Bdf.render("multi:metadataform", {
        action: Bdf.URL + "multi-admin",
        formId: formId,
        labelArray: Bdf.toLabelArray(metadata.labelMap),
        labelsLocKey: "_ title.multi.titlelabels",
        attributes: Bdf.attrMapToString(metadata.attrMap),
        attributesLocKey: "_ title.multi.attributes",
        workingLangs: metadata.langConfiguration.workingLangArray.join(";"),
        authority: metadata.authority
    }));
    Bdf.Deploy.init($$("layout_main"));
    $$(formId).ajaxForm({
        beforeSerialize: function ($form, options) {
            attributesCodeMirror.save();
            return true;
        },
        dataType: "json",
        success: function (data, textStatus, jqXHR, $form) {
            Pane.setChange(false);
            _saveCallback(data);
        }
    });
    var attributesCodeMirror = Bdf.toCodeMirror(ID(attributesId), {
        lineWrapping: false,
        lineNumbers: false,
        indentUnit: 4,
        theme: 'bdf',
        mode: "attributes"
    });
    attributesCodeMirror.on("change", function () {
        Pane.setChange(true);
    });
    Pane.checkState();
    
    
    function _saveCallback(data) {
        if (Bdf.isError(data)) {
            return;
        }
        Bdf.showCommandMessage(data.commandMessage);
        if ((data.commandMessage) && (data.commandMessage.type === "done")) {
            Bdf.updateDefaultValues($$(formId));
            Multi.Metadata.update(data.metadata);
        }
    }
    
};

Multi.Metadata.loadAjax = function (callback) {
    $.ajax({
        url: Bdf.URL + "multi-admin",
        data: {
            json: "metadata"
        },
        dataType: Bdf.jsonDataType,
        success: function (data, textStatus) {
            if (Multi.testAuthentification(data)) {
                Bdf.processObject(data, "metadata", callback);
            }
        }
    });
};
